/* c_sock.c - client for tcp-socket */
#include "inet.h"
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>

int paketsize,paketnumbers;

/* read from 0, write to socket, read from socket, write to 1 */

talk(sockfd,pks,pkn)
register int sockfd;
int pks,pkn;
{
   int n,p,i,c;
   char sendline[65000];
   long lgt, npkn, nlgt;

   lgt=pks;
   nlgt=htonl(lgt);
   npkn=htonl(pkn);
   write(sockfd,&nlgt,sizeof(nlgt));
   read(sockfd,&nlgt,sizeof(nlgt));
   write(sockfd,&npkn,sizeof(npkn));
   read(sockfd,&npkn,sizeof(npkn));

   for (i=0; i< 65000; i++) { sendline[i] = i % 256 ; }
   
   for (p=0; p< pkn ; p++) { 
       if ((n=write(sockfd,sendline,pks))!= pks) {
           fprintf(stderr,"error writing paket %d: want: %d, send: %d\n",p,pks,n);
       }
       c=0;
       while( c < lgt ) {
         n=read(sockfd,&sendline[c],lgt-c);
 	 if (n <= 0) {
               fprintf(stderr,"error read: %d, gelesen: %d\n",n,c);
 			    exit(1);
         }
         c+=n;
       }
   }
}

main(argc,argv)
int argc;
char *argv[];
{
   int sockfd;
   struct sockaddr_in serv_addr;
   struct hostent *hp;
   int paketsize,paketnumbers;

   if (argc != 4) {
           fprintf(stderr,"use: %s <hostname> <blocksize> <packetsnumber>\n",argv[0]);
           exit(1);
   }
   hp = gethostbyname(argv[1]);
   if (hp == NULL) {
     (void) printf("host information for %s not found\n", argv[1]);
      exit (3);
   }
   paketsize= atoi(argv[2]);
   paketnumbers= atoi(argv[3]);
   if ( paketsize >= 65000 ) {
       (void) printf("paketsize to big: %d\n",paketsize);
       exit(4);
   }
   fprintf(stderr,"Host:%s,Paketlaenge: %d, Anzahl der Pakete: %d\n",argv[1],paketsize,paketnumbers);
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(SERV_TCP_PORT);
   (void) memcpy(&serv_addr.sin_addr.s_addr, *hp->h_addr_list, 
                      sizeof (serv_addr.sin_addr.s_addr));
   if ((sockfd = socket(AF_INET,SOCK_STREAM,0)) < 0) {
      fprintf(stderr,"c_sock: can't open stream socket\n");
      exit(-1);
   }
   if (connect(sockfd, (struct sockaddr *) &serv_addr,
            sizeof(serv_addr)) < 0)  {
      fprintf(stderr,"c_sock: can't connect to server\n");
      exit(-2);
   }
   talk(sockfd,paketsize,paketnumbers);
   exit(0);
}
