/* s_sock1.c  - Server for tcp-socket */

#include "inet.h"


talk(sockfd,cln)
int sockfd;
char *cln;
{ 
   int n,pid;
   char sendline[MAXLINE];
   char client[30]="0.0.0.0";
   strcpy(client,cln);
   strcat(client," ");
   if (pid=fork()){
     while(write(1,client,strlen(client)),
	   write(1,"s> ",3),(n=read(0,sendline,MAXLINE)) > 0) 
                        if (write(sockfd,sendline,n) !=n) break;
     write(1,"\nEOF\n",5);
     close(sockfd);
     kill(pid,15);
   }
   else {
     while((n=read(sockfd,sendline,MAXLINE)) > 0) {
        write(1,"\n",1);
        write(1,sendline,n);
	write(1,client,strlen(client));
        write(1,"S> ",3);
     }
     write(1,"\ndisconnect\n",12);
     close(sockfd);
     kill(getppid(),15);
   }
   exit(0);
}
/*next*/
main(argc,argv)
int argc;
char *argv[];
{
   int sockfd,newsockfd, clilen, childpid;
   struct sockaddr_in  cli_addr, serv_addr;
        int i;

   if (( sockfd = socket(AF_INET, SOCK_STREAM, 0)) < 0) {
      fprintf(stderr,"server: can't open stream socket\n");
      exit(-1);
        }
   bzero((char *) &serv_addr, sizeof(serv_addr));
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
   serv_addr.sin_port = htons(SERV_TCP_PORT1);
   if ((i=bind(sockfd, (struct sockaddr *) &serv_addr,
                                    sizeof(serv_addr))) < 0){
      fprintf(stderr,
                   "server: can't bind local address: %d\n",i);
      exit(-2);
   }
   listen(sockfd,5);
   for (;;) {
      clilen = sizeof(cli_addr);
      newsockfd = 
         accept(sockfd, (struct sockaddr *) &cli_addr, &clilen);
      if  (newsockfd < 0){
         fprintf(stderr,"server: accept error\n");
         exit(-3);
      }
      fprintf(stderr,"Client: %s\n",inet_ntoa(cli_addr.sin_addr));
      if ((childpid = fork()) < 0) {
         fprintf(stderr,"server: fork error\n");
         exit(-4);
      }
      else if (childpid == 0) {
              close(sockfd);
              talk(newsockfd,inet_ntoa(cli_addr.sin_addr));
              exit(0);
           }
      close(newsockfd);
   }
}
